package rocks.zipcode.quiz5.collections;

import rocks.zipcode.quiz5.objectorientation.Spice;

import java.util.*;

/**
 * @author leon on 27/12/2018.
 */
public class Food {

    private List<Spice> spiceList;
    private Map<Class<? extends Spice>, Integer> spices;

    public Food() {
        this.spiceList = new ArrayList<>();
        this.spices = new LinkedHashMap<>();
    }

    public List<Spice> getAllSpices() {
        return spiceList;
    }

    public Map<Class<? extends Spice>, Integer> getSpiceCount() {
        return spices;
    }

    public void applySpice(Spice spice) {
        spiceList.add(spice);

        if (!spices.containsKey(spice.getClass())) {
            spices.put(spice.getClass(), 1);
        } else {
            spices.put(spice.getClass(), spices.get(spice.getClass()) + 1);
        }
    }

}
