package rocks.zipcode.quiz5.collections;

import java.util.Map;
import java.util.TreeMap;

public class WordCounter {

    private Map<String, Integer> wordCount;

    public WordCounter(String... strings) {
        this.wordCount = new TreeMap<>();
        countWords(strings);
    }

    public Map<String, Integer> getWordCountMap() {
        return this.wordCount;
    }

    private void countWords(String... strings){
        for (String string : strings) {
            if (!wordCount.containsKey(string)) {
                wordCount.put(string, 1);
            } else {
                wordCount.put(string, wordCount.get(string) + 1);
            }
        }
    }

}
