package rocks.zipcode.quiz5.fundamentals;

import java.util.*;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.charAt(getMiddleIndex(string));
    }

    public static Integer getMiddleIndex(String string) {
        return string.length() / 2;
    }

    public static String capitalizeMiddleCharacter(String str) {
        StringBuilder builder = new StringBuilder(str);
        builder.replace(getMiddleIndex(str), getMiddleIndex(str) + 1, getMiddleCharacter(str).toString().toUpperCase());

        return builder.toString();
    }

    public static String lowerCaseMiddleCharacter(String str) {
        StringBuilder builder = new StringBuilder(str);
        builder.replace(getMiddleIndex(str), getMiddleIndex(str) + 1, getMiddleCharacter(str).toString().toLowerCase());

        return builder.toString();
    }

    public static Boolean isIsogram(String str) {
        List<Character> characters = new ArrayList<>();

        for (int i = 0; i < str.length(); i++) {
            if (!characters.contains(str.charAt(i))) {
                characters.add(str.charAt(i));
            } else {
                return false;
            }
        }

        return true;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        for (int i = 1; i < str.length(); i++) {
            if (str.charAt(i) == str.charAt(i - 1)) {
                return true;
            }
        }

        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        Set<String> duplicateChars = new HashSet<>();

        for (int i = 1; i < str.length(); i++) {
            if (str.charAt(i) == str.charAt(i - 1)) {
                duplicateChars.add(str.substring(i, i + 1));
            }
        }

        for (String character : duplicateChars) {
            str = str.replaceAll(character, "");
        }

        return str;
    }

    public static String invertCasing(String str) {
        StringBuilder builder = new StringBuilder();

        for (int i = 0; i < str.length(); i++) {
            if (Character.isUpperCase(str.charAt(i))) {
                builder.append(Character.toLowerCase(str.charAt(i)));
            } else {
                builder.append(Character.toUpperCase(str.charAt(i)));
            }
        }

        return builder.toString();
    }
}